searchNodes=[{"doc":"Allows to store Membrane.RTC.Engine metrics reports in a database.","ref":"Membrane.RTC.Engine.TimescaleDB.html","title":"Membrane.RTC.Engine.TimescaleDB","type":"module"},{"doc":"Stores Membrane.RTC.Engine metrics report in the database using :repo module passed in Application environment.","ref":"Membrane.RTC.Engine.TimescaleDB.html#store_report/1","title":"Membrane.RTC.Engine.TimescaleDB.store_report/1","type":"function"},{"doc":"Worker responsible for deleting obsolete records from the database. By default started under the application's supervision tree with params passed in :membreane_rtc_engine_timescaledb config (params passed in config, used to start worker, are these same, as expected by start/1 and start_link/1 ) start/1 and start_link/1 functions expect a keyword list as an argument, with the following keys: :repo (required) is a module, that uses Ecto.Repo :cleanup_interval (default: 1 hour) is the number of seconds between database cleanups :metrics_lifetime (default: 24 hours) is the number of seconds that must pass from creation before each metric can be deleted during cleanup The keyword may also include GenServer options, see GenServer.option/0 for reference.","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#child_spec/1","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#start/1","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.start/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#start_link/1","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.start_link/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#t:cleaner/0","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.cleaner/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#t:option/0","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.option/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Cleaner.html#t:options/0","title":"Membrane.RTC.Engine.TimescaleDB.Cleaner.options/0","type":"type"},{"doc":"Provides functions facilitating releasing a project, that has a dependency to this library","ref":"Membrane.RTC.Engine.TimescaleDB.GrafanaHelper.html","title":"Membrane.RTC.Engine.TimescaleDB.GrafanaHelper","type":"module"},{"doc":"Takes the target path, where the content from priv/grafana will be copied.","ref":"Membrane.RTC.Engine.TimescaleDB.GrafanaHelper.html#cp_grafana_directory/1","title":"Membrane.RTC.Engine.TimescaleDB.GrafanaHelper.cp_grafana_directory/1","type":"function"},{"doc":"Migrations creating DB tables required by this library to function. To execute migrations, run Elixir.Membrane.RTC.Engine.TimescaleDB.Migrations.up() . To undo them and drop tables, run Elixir.Membrane.RTC.Engine.TimescaleDB.Migrations.down() . Suggested way of using functions from this module, is to create a migration module in your own project and call them there, eg. defmodule MyApp.CreateRtcEngineTimescaledbTables do use Ecto.Migration @spec up ( ) :: :ok def up ( ) do :ok = Elixir.Membrane.RTC.Engine.TimescaleDB.Migrations . up ( ) end @spec down ( ) :: :ok def down ( ) do :ok = Elixir.Membrane.RTC.Engine.TimescaleDB.Migrations . down ( ) end end","ref":"Membrane.RTC.Engine.TimescaleDB.Migrations.html","title":"Membrane.RTC.Engine.TimescaleDB.Migrations","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Migrations.html#down/0","title":"Membrane.RTC.Engine.TimescaleDB.Migrations.down/0","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Migrations.html#up/0","title":"Membrane.RTC.Engine.TimescaleDB.Migrations.up/0","type":"function"},{"doc":"Module responsible for putting data to TimescaleDB.","ref":"Membrane.RTC.Engine.TimescaleDB.Model.html","title":"Membrane.RTC.Engine.TimescaleDB.Model","type":"module"},{"doc":"Takes Membrane.RTC.Engine.Metrics.rtc_engine_report() and puts it to database.","ref":"Membrane.RTC.Engine.TimescaleDB.Model.html#insert_report/2","title":"Membrane.RTC.Engine.TimescaleDB.Model.insert_report/2","type":"function"},{"doc":"Takes count and interval. Deletes records in database older than count * interval . interval might be &quot;year&quot; , &quot;month&quot; , &quot;week&quot; , &quot;day&quot; , &quot;hour&quot; , &quot;minute&quot; , &quot;second&quot; , &quot;millisecond&quot; or &quot;microsecond&quot; .","ref":"Membrane.RTC.Engine.TimescaleDB.Model.html#remove_outdated_records/3","title":"Membrane.RTC.Engine.TimescaleDB.Model.remove_outdated_records/3","type":"function"},{"doc":"Model representing a set of peer metrics from Membrane.RTC.Engine metrics report.","ref":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics.html","title":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics.html#changeset/2","title":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics.changeset/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics.html#t:t/0","title":"Membrane.RTC.Engine.TimescaleDB.Model.PeerMetrics.t/0","type":"type"},{"doc":"Model representing a set of track metrics from Membrane.RTC.Engine metrics report.","ref":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics.html","title":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics","type":"module"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics.html#changeset/2","title":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics.changeset/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics.html#t:t/0","title":"Membrane.RTC.Engine.TimescaleDB.Model.TrackMetrics.t/0","type":"type"},{"doc":"A worker responsible for storing reports in the database.","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html","title":"Membrane.RTC.Engine.TimescaleDB.Reporter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#child_spec/1","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.child_spec/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#start/1","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.start/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#start_link/1","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.start_link/1","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#store_report/2","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.store_report/2","type":"function"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#t:option/0","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.option/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#t:options/0","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.options/0","type":"type"},{"doc":"","ref":"Membrane.RTC.Engine.TimescaleDB.Reporter.html#t:reporter/0","title":"Membrane.RTC.Engine.TimescaleDB.Reporter.reporter/0","type":"type"},{"doc":"This repository contains functions, that allows storing Membrane.RTC.Engine metrics reports in a database. It is part of Membrane Multimedia Framework .","ref":"readme.html","title":"","type":"extras"},{"doc":"The package can be installed by adding membrane_rtc_engine_timescaledb to your list of dependencies in mix.exs : def deps do [ { :membrane_rtc_engine_timescaledb , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"To use membrane_rtc_engine_timescaledb , you have to have: running PostgreSQL database with Timescale extension config for :membrane_rtc_engine_timescaledb configured Ecto repo in your project Ecto migration calling Membrane.RTC.Engine.TimescaleDB.Migrations.up() To create such a migration, execute $ mix ecto.gen.migration create_rtc_engine_timescaledb_tables , what will create new migration module, and add there calls to up/0 and down/0 from Membrane.RTC.Engine.TimescaleDB.Migrations . Your new migration module should look like the example below defmodule MyApp.CreateRtcEngineTimescaledbTables do use Ecto.Migration alias Membrane.RTC.Engine.TimescaleDB.Migrations @spec up ( ) :: :ok def up ( ) do :ok = Migrations . up ( ) end @spec down ( ) :: :ok def down ( ) do :ok = Migrations . down ( ) end end Then, execute $ mix ecto.migrate to run the newly created migration. To set up config for this library, put the following line in your config file: config :membrane_rtc_engine_timescaledb , repo : MyApp.Repo , cleanup_interval : 60 * 60 , metrics_lifetime : 60 * 60 * 24 where repo (required) is a module in your project, that uses Ecto.Repo cleanup_interval (default: 1 hour) is the number of seconds between database cleanups metrics_lifetime (default: 24 hours) is the number of seconds that must pass from creation before each metric can be deleted during cleanup","ref":"readme.html#usage","title":" - Usage","type":"extras"},{"doc":"Metrics stored in the database using membrane_rtc_engine_timescaledb can be simply visualized using Grafana. To start the dashboard with RTC Engine metrics, create a volume with Grafana configuration files taken from priv/grafana/provisioning and mount it in the Grafana container at the default location: /etc/grafana/provisioning . When assembling an Elixir release with a dependency on membrane_rtc_engine_timescaledb the config files will be put in lib/membrane_rtc_engine_timescaledb-0.1.0/priv/grafana/provisioning directory inside the release. If you want to put them in a different location (e.g. one that doesn't contain the library version, possibly changing over time), create an additional release step in mix.exs and use Membrane.RTC.Engine.TimescaleDB.GrafanaHelper.cp_grafana_directory/1 inside, like in the example below: defmodule Example.MixProject do use Mix.Project def project do [ project : :example_project , ... releases : [ example_project : [ steps : [ :assemble , &amp; cp_grafana_config / 1 ] ] ] ] end defp cp_grafana_config ( release ) do Membrane.RTC.Engine.TimescaleDB.GrafanaHelper . cp_grafana_directory ( release . path ) release end end You can create a volume containing priv/grafana/provisioning , by declaring it in your docker-compose.yml volumes: grafana-provisioning: and adding it to the container with the Elixir project and to the Grafana container services: ... elixir_project: ... volumes: - type: volume source: grafana-provisioning target: &lt;path to grafana/provisioning in the related Docker image&gt; grafana: ... depends_on: - elixir_project volumes: - type: volume source: grafana-provisioning target: /etc/grafana/provisioning read_only: true volume: nocopy: true Beyond that, you have to set the following environment variables for your docker container DB_NAME - name of the database, that you store your metrics in DB_USERNAME - username used to log into the database DB_PASSWORD - password used to log into the database DB_URL - database URL in the form of host:port , eg. localhost:5432 To see an example, of how you can pass volumes and environment variables to the Docker containers, see membrane_videoroom docker-compose.yml","ref":"readme.html#metrics-visualisation-with-grafana","title":" - Metrics visualisation with Grafana","type":"extras"},{"doc":"To start tests, you have to run $ docker-compose up command, to have a running database docker container. To set up the database before tests, run $ MIX_ENV=test mix ecto.reset in second terminal window. Tests can be run with $ mix test --include long_running command.","ref":"readme.html#running-tests","title":" - Running tests","type":"extras"},{"doc":"Copyright 2020, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":" - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]